from infra_cep_helper import CEPCollecting
import os

ploop_dict = {}


class ploop(CEPCollecting):
    def get_ploops(self):
        ploop_list = []
        for root, dirs, files in os.walk("/sys/block/"):
            for dir in dirs:
                if dir.startswith("ploop"):
                    ploop_list.append(os.path.join(root, dir))
        return ploop_list

    def ploop_info(self, ploop):
        pdelta = ploop + '/pdelta/0/io'
        ptune = ploop + '/ptune/discard_granularity'
        # just ignore if not exist
        try:
            with open(pdelta) as f:
                pdelta_value = f.read().split()
                if ploop not in ploop_dict:
                    ploop_dict[ploop] = [pdelta_value[0]]
                else:
                    ploop_dict[ploop].append(pdelta_value[0])
        # just ignore if can't read
        except IOError:
            pass

        try:
            with open(ptune) as f:
                ptune_value = f.read().split()
                if ploop not in ploop_dict:
                    ploop_dict[ploop] = [ptune_value[0]]
                else:
                    ploop_dict[ploop].append(ptune_value[0])
        # just ignore if can't read
        except IOError:
            pass

    def fill_results(self):
        for ploop in self.get_ploops():
            self.ploop_info(ploop)
        self.result["ploop_info"] = ploop_dict


def main():
    o = ploop()
    o.run()


if __name__ == "__main__":
    main()
